/*@ requires n >= 1 && \valid(a+(0..n-1));
    ensures \forall integer i; 0 <= i < n-1 ==> a[i] == \old(a[i])+1;
    ensures (\forall integer i; 0 <= i < n-1 ==> \old(a[i]) <= \old(a[i+1])) ==>
      (\forall integer i; 0 <= i < n-1 ==> a[i] <= a[i+1]);
    assigns a[0..n-1];
*/ 
void add1 (int* a, int n) 
{ int i;
  
  /*@
      loop assigns i, a[0..n-1];
      loop invariant 0 <= i <= n;
      loop invariant
        \forall integer j; 0 <= j < i ==> a[j] == \at(a[j], Pre)+1;
      loop invariant
        \forall integer j; i <= j < n ==> a[j] == \at(a[j], Pre);
  */
  for (i=0; i<n; i++)
    a[i]++;
} 
